<template>
  <b-input-group id="searchApGroup" class="mb-2">
    <template #prepend>
      <b-input-group-text><i-bi-search /></b-input-group-text>
    </template>
    <b-form-input
      v-model="searchString"
      debounce="1000"
      :placeholder="$t('searchAP')"
    />
    <template v-if="filteredSearch" #append>
      <b-dropdown variant="outline-secondary" :auto-close="false">
        <template #button-content>
          <i-bi-filter />
        </template>
        <b-dropdown-form class="filter-form">
          <b-form-group
            class="mb-3"
            :label="$t('state')"
            label-size="sm"
            label-for="dropdown-form-state"
            :description="$t('stateFilterDescription')"
          >
            <b-form-select
              id="dropdown-form-state"
              v-model="searchParameters.state"
              class="mb-0"
              :options="states"
              size="sm"
            ></b-form-select>
          </b-form-group>

          <b-form-group
            :label="$t('creator')"
            :description="$t('creatorFilterDescription')"
            class="mb-3"
            label-class="fw-bold pt-0"
            label-size="sm"
            label-for="dropdown-form-creator"
          >
            <b-form-input
              id="dropdown-form-creator"
              v-model="searchParameters.creator"
              class="mb-0"
              debounce="1000"
              size="sm"
              :placeholder="$t('creator')"
            ></b-form-input>
          </b-form-group>
          <b-form-group
            class="mb-3"
            label-class="fw-bold pt-0"
            :label="$t('dateFilters')"
            label-size="sm"
            label-for="minimum-input"
            :description="$t('dateFiltersDescription')"
          >
            <b-input-group
              size="sm"
              prepend="Minimum"
              append="Maximum"
              class="mb-0"
            >
              <b-form-input
                id="minimum-input"
                v-model="searchParameters.from"
                size="sm"
                type="date"
              ></b-form-input>
              <b-form-input
                id="maximum-input"
                v-model="searchParameters.to"
                size="sm"
                type="date"
              ></b-form-input>
            </b-input-group>
          </b-form-group>
          <b-form-group
            v-if="subjects.length > 0"
            :label="$t('subject')"
            class="mb-3"
            label-size="sm"
            label-for="dropdown-form-subject"
            :description="$t('subjectFilterDescription')"
          >
            <b-form-select
              id="dropdown-form-subject"
              v-model="searchParameters.subject"
              class="mb-0"
              :options="subjects"
              size="sm"
            >
              <template #first>
                <b-form-select-option :value="null">{{
                  $t("pleaseSelectOption")
                }}</b-form-select-option>
              </template></b-form-select
            >
          </b-form-group>
          <b-form-group
            v-if="communities.length > 0"
            :label="$t('communitiesLabel')"
            class="mb-3"
            label-size="sm"
            label-for="dropdown-form-community"
            :description="$t('communitiesFilterDescription')"
          >
            <b-form-select
              id="dropdown-form-community"
              v-model="searchParameters.community"
              class="mb-0"
              :options="communities"
              size="sm"
            >
              <template #first>
                <b-form-select-option :value="null">{{
                  $t("pleaseSelectOption")
                }}</b-form-select-option>
              </template></b-form-select
            >
          </b-form-group>
        </b-dropdown-form>
      </b-dropdown>
    </template>
  </b-input-group>
</template>

<script lang="ts">
import { defineComponent } from "vue";

import serviceProvider from "@/util/service-providers/service-provider";

import { subjects } from "@/util/shaclTypes";

import { useMainStore } from "@/store";
import type {
  ApplicationProfile,
  ApplicationProfileSearchParameters,
} from "@/types/application-profile";
import { useLocalStorage } from "@vueuse/core";

export default defineComponent({
  name: "SearchAP",
  props: {
    sessionStoredApplicationProfiles: {
      required: false,
      default: 0,
      type: Number,
    },
    token: {
      default: "",
      type: String,
    },
  },
  setup() {
    const mainStore = useMainStore();
    const searchString = useLocalStorage<string>(
      "aims.applicationProfile.searchString",
      "",
    );

    return { mainStore, searchString };
  },
  data() {
    return {
      communities: [] as { text: string; value: string }[],
      filteredSearch: serviceProvider.filtered_search,
      foundApplicationProfiles: [] as ApplicationProfile[],
      searchParameters: {
        community: null,
        language: this.$i18n.locale as "en" | "de",
        state: "public",
        creator: undefined,
        from: undefined,
        to: undefined,
        subject: null,
      } satisfies ApplicationProfileSearchParameters,
      states: ["public", "approved"],
      subjects: subjects,
    };
  },
  computed: {
    draftApplicationProfiles(): ApplicationProfile[] {
      return this.mainStore.draftValues;
    },
  },
  watch: {
    "$i18n.locale"() {
      this.searchParameters.language = this.$i18n.locale as "en" | "de";
    },
    draftApplicationProfiles() {
      this.submitAPs();
    },
    searchParameters: {
      handler(_, __) {
        this.retrieveAPs();
      },
      deep: true,
    },
    searchString() {
      this.retrieveAPs();
    },
    sessionStoredApplicationProfiles() {
      this.retrieveAPs();
    },
    token() {
      this.retrieveAPs();
    },
  },
  async created() {
    this.retrieveAPs();
    if (serviceProvider.apiConnection.getCommunities) {
      const result = await serviceProvider.apiConnection.getCommunities();
      this.communities = result.map((x) => {
        return {
          text: x.name,
          value: x.name,
        };
      });
    }
  },
  methods: {
    async retrieveAPs() {
      this.$emit("searching", true);
      try {
        this.foundApplicationProfiles =
          await serviceProvider.apiConnection.searchApplicationProfiles(
            this.searchString,
            // Create new object to filter empty values
            {
              language: this.searchParameters.language,
              community: this.searchParameters.community ?? undefined,
              creator: this.searchParameters.creator ?? undefined,
              from: this.searchParameters.from ?? undefined,
              to: this.searchParameters.to ?? undefined,
              state: this.searchParameters.state ?? undefined,
              subject: this.searchParameters.subject ?? undefined,
            },
          );
        this.submitAPs();
      } finally {
        this.$emit("searching", false);
      }
    },
    submitAPs() {
      this.$emit("applicationProfiles", [
        ...this.mainStore.searchApplicationProfiles(this.searchString),
        ...this.foundApplicationProfiles,
      ]);
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.filter-form {
  width: 30rem;
}
</style>

<style>
#searchApGroup .dropdown-toggle {
  display: flex;
  align-items: center;
}
</style>
